import logging
import argparse
from pyftg.gateway import Gateway
from Agent import SoundAgent

#Based on: https://github.com/TeamFightingICE/PythonAISamples/blob/master/Main_PyAIvsPyAI.py

def start_game(port: int):
    gateway = Gateway(port=port)
    character = 'ZEN'
    game_num = 1
    agent1 = SoundAgent()
    agent2 = SoundAgent()
    gateway.register_ai("SoundAgent", agent1)
    gateway.register_ai("SoundAgent", agent2)
    gateway.run_game([character, character], ["SoundAgent", "SoundAgent"], game_num)
    gateway.close()

if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('--log', default='INFO', type=str, choices=['DEBUG', 'INFO', 'WARNING', 'ERROR', 'CRITICAL'])
    parser.add_argument('--port', default=50051, type=int, help='Port used by DareFightingICE')
    args = parser.parse_args()
    logging.basicConfig(level=args.log)
    start_game(args.port)

